#ifndef RANDOMBAG_HPP
#define RANDOMBAG_HPP

#include <cstddef>
#include <vector>

template <typename T>
class RandomBag {

public:

    ////////////////////////////////////////
    class iterator {

    public:

        iterator( T *b, T *f, T *e );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename RandomBag<T>::iterator other );

    private:

        T *begin;
        T *first;
        T *end;
        size_t curr;
        std::vector<size_t> order;
        };

    ////////////////////////////////////////
    RandomBag( void );
    ~RandomBag( void );

    void add( T &item );

    bool is_empty( void );
    size_t size( void );

    iterator begin( void );
    iterator end( void );

private:

    size_t N;
    size_t max;
    T *data;

    void resize( size_t new_max );
    };



#endif

